import { Tool } from 'substance'

class TrackChangeControlTool extends Tool {
  renderButton ($$) {
    const el = super.renderButton($$)
    let trackChangesMode = this.isTrackChangesOn()
    if (trackChangesMode === true) el.addClass('track-changes-active')
    return el
  }

  getSurface () {
    const surfaceManager = this.context.surfaceManager
    const containerId = this.context.controller.props.containerId
    return surfaceManager.getSurface(containerId)
  }

  isTrackChangesOn () {
    const surface = this.getSurface()
    if (!surface) return
    return surface.props.trackChanges
  }
}

TrackChangeControlTool.type = 'track-change-enable'

export default TrackChangeControlTool
