import { Tool } from 'substance'

class TrackChangeControlViewTool extends Tool {
  renderButton ($$) {
    const el = super.renderButton($$)
    let trackChangesViewMode = this.isTrackChangesViewOn()
    if (trackChangesViewMode === true) el.addClass('track-changes-view-active')
    return el
  }

  getSurface () {
    const surfaceManager = this.context.surfaceManager
    const containerId = this.context.controller.props.containerId
    return surfaceManager.getSurface(containerId)
  }

  isTrackChangesViewOn () {
    const surface = this.getSurface()
    if (!surface) return
    return surface._owner.state.trackChangesView
  }
}

TrackChangeControlViewTool.type = 'track-change-toggle-view'

export default TrackChangeControlViewTool
