import TrackChange from './TrackChange'
import TrackChangeCommand from './TrackChangeCommand'
import TrackChangeComponent from './TrackChangeComponent'
import TrackChangeHTMLConverter from './TrackChangeHTMLConverter'
import TrackChangeControlTool from './TrackChangeControlTool'
import TrackChangeControlViewTool from './TrackChangeControlViewTool'
import TrackChangeControlCommand from './TrackChangeControlCommand'
import TrackChangeControlViewCommand from './TrackChangeControlViewCommand'

export default {
  name: 'track-change',
  configure: function (config) {
    config.addNode(TrackChange)

    config.addComponent(TrackChange.type, TrackChangeComponent)
    config.addConverter('html', TrackChangeHTMLConverter)

    config.addTool('track-change-enable', TrackChangeControlTool, {
      target: 'track-change-enable'
    })

    config.addTool('track-change-toggle-view', TrackChangeControlViewTool, {
      target: 'track-change-toggle-view'
    })

    config.addCommand('track-change-enable', TrackChangeControlCommand)
    config.addCommand('track-change-toggle-view', TrackChangeControlViewCommand)
    config.addCommand(TrackChange.type, TrackChangeCommand, { nodeType: TrackChange.type })

    config.addIcon('track-change', { 'fontawesome': 'fa-eye' })

    config.addLabel('track-change', {
      en: 'Track Changes'
    })
  }
}
